# upgrade client by reflux
# (c) 1998 Plazmodium Studios

on ^ctcp_reply "* UPGRADE_availible" {  upgrade_CS $0- } 

on ^exec "spc_upgrade *" {
#echo - $1 -
	if ([$1] == [finished]) { finish_up } {
	echo $cparse("%n\[%gSpectra Update%n\] $1-") }
}        
#on ^exec "spc_upgrade_kern *" {
#echo $cparse("%n\[%gUpgrading Spectra Kernel%n\] $1-")
#}          
#on ^exec "spc_upgrade_mods *" {
#echo $cparse("%n\[%gUpgrading Spectra Modules%n\] $1-")
#}          

alias upgrade_CS {
	input "Would you like to upgrade to spectra version $2 [no/yes]: " 
	{ if ([$0] == [yes]) { do_upgrade }  { kecho Spectra Upgrade Canceled }}
}

alias upgrade {
	ctcp reflux SPECTRA_UPGRADE $kernelver $spectra.ver
}

alias do_upgrade {
	^window new
	^window hide_others
	^set double_status_line 2
	^window double on
	^window split on
	^window set status_format3 ${hblu}-----------${hgrn}Spectra Upgrade System ${hblu}-----------${wht}
	echo Welcome to the Spectra Upgrade system.
	echo
	echo --- ${HRED} WARNING ${wht}
	echo your copy of spectra is about to be upgraded to the newest release
	echo due to the way this script works, it is possible that it might
	echo be insecure and cause damage to your system. it is recommended that you
	echo read through the spectra directory, ~/.spectra/ looking at all the files
	echo to make shure there are no dangerous scripts.
	echo ---
	echo
	echo upgrading will delete any changes you have made in the
	echo ~/.spectra/  directory
	echo
	echo this proccess will change your dcc_dldir variable untill it is complete.
	echo it will allso enable autoget dcc's (/toggle dcc_autoget)
	echo
	input "Are you sure you wish to continue? [no/yes]: "{ 
	        if ([$0] == [yes]) { 
			if ( fexist( ~/.spectra/upgrade_dir ) = [-1] ) {
				exec mkdir ~/.spectra/upgrade_dir
			}
			@old_dldir=[$dcc_dldir]
			@dcc_autoget_old=[$dcc_autoget]
			set dcc_dldir ~/.spectra/upgrade_dir
			set dcc_autoget on
			msg reflux spectra_send_upgrade
			echo you only get one chance to enter 'done' at the correct time, or the
			echo upgrade will not complete successfully.
			input "When you see the dcc transfer finish, type 'done': " {
				 if ([$0] == [done]) {
					set dcc_dldir $old_dldir
					set dcc_autoget $dcc_autoget_old
					exec -name spc_upgrade ~/.spectra/bin/upgrade
					#wait %spc_upgrade -cmd input "Spectra Upgrade complete, type 'ok' to reload kernel/exit update system: "
					#{ if ([$0] == [ok]) {           
					#load ~/.spectra/spectra.irc
					#^window kill
					#}}

				} {
					^window kill 
					kecho Upgrade Aborted

					#^window kill
				}
			}


		} { 
			^window kill 
			kecho Spectra Upgrade Canceled 
			#^window kill
		}

	}

}
 


alias finish_up {
input "Spectra Upgrade complete, Hit a key to reload the kernel.. [any key]"
{ 
^window kill
load ~/.spectra/spectra.irc
#^window kill
msg reflux Spectra ${spectra.ver}, ${kernelver}, Upgrade completed sucessfully
}
}                   

alias update upgrade

                             